config/routes.rb
Rails.application.routes.draw do
  root 'posts#index'
  resources :posts, only: [:index, :show] do
    collection do
      get 'parse'
    end
  end
end

app/models/post.rb
class Post < ActiveRecord::Base
  validates_uniqueness_of :url
  paginates_per 15

  def self.add_record(node)
    link_with_title = node.at_css('.title a')
    author = node.next.at_css('.subtext a').text.strip
    new(title: link_with_title.text, url: link_with_title['href'], author: author).save
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update, :destroy]

  # GET /posts
  # GET /posts.json
  def index
    @posts = Post.all.order(created_at: :desc).page params[:page]
    respond_to do |format|
      format.json {@posts}
      format.html
    end
  end

  # GET /posts/1
  # GET /posts/1.json
  def show
    respond_to do |format|
      format.json {@post}
      format.html
    end
  end

  def parse
    ParserWorker.perform_async
    redirect_to :back, notice: 'Parsing started!'
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_post
      @post = Post.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def post_params
      params.require(:post).permit(:title, :author, :url)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/layouts/_header.html.erb
<nav class="navbar navbar-inverse">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <a class="navbar-brand" href="#">YcombinatorNewsParser</a>
    </div>
    <div id="navbar" class="navbar-collapse collapse">
      <ul class="nav navbar-nav">
        <li class="active">
          <%= link_to 'Home', root_path %>
        </li>
      </ul>
      <%= link_to 'Parse News!', parse_posts_path, class: 'btn btn-sm btn-success navbar-btn pull-right' %>
    </div><!--/.nav-collapse -->
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>YcombinatorNewsParser</title>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>
<%= render 'layouts/header' %>
<div class="container">
  <%= yield %>
</div>

</body>
</html>

app/views/posts/index.html.erb
<div class="row">
  <div class="col-md-12">
    <p id="notice"><%= notice %></p>

    <h1>Listing Posts</h1>

    <table class="table table-striped table-responsive table-hover">
      <thead>
      <tr>
        <th>Title</th>
        <th class="author">Author</th>
        <th class="url">Url</th>
        <th></th>
      </tr>
      </thead>

      <tbody>
      <% @posts.each do |post| %>
          <tr>
            <td><%= post.title %></td>
            <td class="author"><%= post.author %></td>
            <td class="url"><%= post.url %></td>
            <td><%= link_to 'Show', post %></td>
          </tr>
      <% end %>
      </tbody>
    </table>
    <%= paginate @posts %>
  </div>
</div>

app/views/posts/show.html.erb
<div class="row">
  <div class="col-md-12">
    <p id="notice"><%= notice %></p>
  </div>
</div>
<div class="row post-info">
  <div class="col-md-12">
    <p>
      <strong>Title:</strong>
      <%= @post.title %>
    </p>
    <p>
      <strong>Author:</strong>
      <%= @post.author %>
    </p>

    <p>
      <%= link_to 'Show Original Post', @post.url, class: 'btn btn-info btn-sm' %>
    </p>
    <p>
      <%= link_to 'Back', :back %>
    </p>
  </div>
</div>